﻿Module = require 'module'
fs = require 'fs'
coffee = (() ->
  try
    return require('coffee-script')
  catch error
    return null)()

instrumentCode = (code, filename) ->
  return code

exports.registerInstrumentor = () ->
  plainJsHandler = require.extensions['.js']
  plainCoffeeHandler = require.extensions['.coffee']
  require.extensions['.js'] = (module, filename) ->
    content = fs.readFileSync filename, 'utf8'
    content = instrumentCode content, filename
    module._compile content, filename
  require.extensions['.coffee'] = (module, filename) ->
    content = fs.readFileSync filename, 'utf8'
    content = coffee.compile content, { bare: true }
    content = instrumentCode content, filename
    module._compile content, filename
  global._$instrumentorEnabled = true

exports.desire = (moduleName) ->
  modulePath = Module._resolveFilename moduleName, module.parent
  moduleText = fs.readFileSync modulePath, 'utf8'
  
  if new RegExp('\.coffee$').test modulePath
    moduleText = coffee.compile moduleText, { bare: true }

  moduleText = instrumentCode moduleText, modulePath if global._$instrumentorEnabled
    
  getterFunction = '\nexports.__get__ = function(varName) { return eval(varName) }'
  setterFunction = '\nexports.__set__ = function(varName, varValue) { eval(varName + "= varValue") }'
  moduleText += getterFunction
  moduleText += setterFunction

  theModule = new Module modulePath, module.parent
  theModule._compile moduleText

  return theModule.exports
